---
title: margin-left
slug: Web/CSS/margin-left
tags:
  - CSS
  - CSS Property
  - Layout
  - Reference
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>margin-left</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property sets the <a href="/en-US/docs/Web/CSS/CSS_Box_Model/Introduction_to_the_CSS_box_model">margin area</a> on the left side of an element. A positive value places it farther from its neighbors, while a negative value places it closer.</p>

<div>{{EmbedInteractiveExample("pages/css/margin-left.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<p>The vertical margins of two adjacent boxes may fuse. This is called <a href="/en-US/docs/CSS/margin_collapsing"><em>margin collapsing</em></a>.</p>

<p>In the rare cases where width is overconstrained (i.e., when all of <code>width</code>, <code>margin-left</code>, <code>border</code>, <code>padding</code>, the content area, and <code>margin-right</code> are defined), <code>margin-left</code> is ignored, and will have the same calculated value as if the <code>auto</code> value was specified.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush:css no-line-numbers notranslate">/* &lt;length&gt; values */
margin-left: 10px;  /* An absolute length */
margin-left: 1em;   /* relative to the text size */
margin-left: 5%;    /* relative to the nearest block container's width */

/* Keyword values */
margin-left: auto;

/* Global values */
margin-left: inherit;
margin-left: initial;
margin-left: unset;
</pre>

<p>The <code>margin-left</code> property is specified as the keyword <code>auto</code>, or a <code>&lt;length&gt;</code>, or a <code>&lt;percentage&gt;</code>. Its value can be positive, zero, or negative.</p>

<h3 id="Values">Values</h3>

<dl>
 <dt>{{cssxref("&lt;length&gt;")}}</dt>
 <dd>The size of the margin as a fixed value.</dd>
 <dt>{{cssxref("&lt;percentage&gt;")}}</dt>
 <dd>The size of the margin as a percentage, relative to the <em>width</em> of the containing block.</dd>
 <dt><code>auto</code></dt>
 <dd>The left margin receives a share of the unused horizontal space, as determined mainly by the layout mode that is used. If the values of <code>margin-left</code> and <code>margin-right</code> are both <code>auto</code>, the calculated space is evenly distributed. This table summarizes the different cases:
 <table class="standard-table">
  <thead>
   <tr>
    <th scope="col">Value of {{cssxref("display")}}</th>
    <th scope="col">Value of {{cssxref("float")}}</th>
    <th scope="col">Value of {{cssxref("position")}}</th>
    <th scope="col">Computed value of <code>auto</code></th>
    <th scope="col">Comment</th>
   </tr>
  </thead>
  <tbody>
   <tr>
    <th><code>inline</code>, <code>inline-block</code>, <code>inline-table</code></th>
    <th><em>any</em></th>
    <th><code>static</code> or <code>relative</code></th>
    <td><code>0</code></td>
    <td>Inline layout mode</td>
   </tr>
   <tr>
    <th><code>block</code>, <code>inline</code>, <code>inline-block</code>, <code>block</code>, <code>table</code>, <code>inline-table</code>, <code>list-item</code>, <code>table-caption</code></th>
    <th><em>any</em></th>
    <th><code>static</code> or <code>relative</code></th>
    <td><code>0</code>, except if both <code>margin-left</code> and <code>margin-right</code> are set to <code>auto</code>. In this case, it is set to the value centering the element inside its parent.</td>
    <td>Block layout mode</td>
   </tr>
   <tr>
    <th><code>block</code>, <code>inline</code>, <code>inline-block</code>, <code>block</code>, <code>table</code>, <code>inline-table</code>, <code>list-item</code>, <code>table-caption</code></th>
    <th><code>left</code> or <code>right</code></th>
    <th><code>static</code> or <code>relative</code></th>
    <td><code>0</code></td>
    <td>Block layout mode (floating element)</td>
   </tr>
   <tr>
    <th><em>any </em><code>table-*</code><em>, except </em><code>table-caption</code></th>
    <th><em>any</em></th>
    <th><em>any</em></th>
    <td><code>0</code></td>
    <td>Internal <code>table-*</code> elements don't have margins, use {{ cssxref("border-spacing") }} instead</td>
   </tr>
   <tr>
    <th><em>any, except <code>flex</code>,</em> <code>inline-flex</code><em>, or </em><code>table-*</code></th>
    <th><em>any</em></th>
    <th><em><code>fixed</code></em> or <code>absolute</code></th>
    <td><code>0</code>, except if both <code>margin-left</code> and <code>margin-right</code> are set to <code>auto</code>. In this case, it is set to the value centering the border area inside the available <code>width</code>, if fixed.</td>
    <td>Absolutely positioned layout mode</td>
   </tr>
   <tr>
    <th><code>flex</code>, <code>inline-flex</code></th>
    <th><em>any</em></th>
    <th><em>any</em></th>
    <td><code>0</code>, except if there is any positive horizontal free space. In this case, it is evenly distributed to all horizontal <code>auto</code> margins.</td>
    <td>Flexbox layout mode</td>
   </tr>
  </tbody>
 </table>
 </dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Setting_left_margin_using_pixels_and_percentages">Setting left margin using pixels and percentages</h3>

<pre class="brush: css notranslate">.content { margin-left: 5%; }
.sidebox { margin-left: 10px; }
.logo    { margin-left: -5px; }
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Box', '#propdef-margin-left', 'margin-left')}}</td>
   <td>{{Spec2('CSS3 Box')}}</td>
   <td>No significant change from CSS 2.1.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS3 Flexbox', '#item-margins', 'margin-left')}}</td>
   <td>{{Spec2('CSS3 Flexbox')}}</td>
   <td>Defines the behavior of <code>margin-left</code> on flex items.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS2.1', 'box.html#margin-properties', 'margin-left')}}</td>
   <td>{{Spec2('CSS2.1')}}</td>
   <td>Like in CSS1, but removes its effect on inline elements.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS1', '#margin-left', 'margin-left')}}</td>
   <td>{{Spec2('CSS1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.margin-left")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{cssxref("margin-top")}}, {{cssxref("margin-right")}}, and {{cssxref("margin-bottom")}} and the {{cssxref("margin")}} shorthand</li>
 <li>The mapped logical properties: {{cssxref("margin-block-start")}}, {{cssxref("margin-block-end")}}, {{cssxref("margin-inline-start")}}, and {{cssxref("margin-inline-end")}} and the shorthands {{cssxref("margin-block")}} and {{cssxref("margin-inline")}}</li>
</ul>
